pipeline {
environment {
	    registry = "4alinfo1/timesheet"
        registryCredential= 'dockerhub'
        dockerImage = ''
}
    agent any
    stages{
        stage('Clone and Clean Repo'){
            steps{
                bat 'git clone https://gitlab.com/saoudi.jebrane/timesheet.git'
                bat 'mvn clean -f timesheet '
            }
        }
        stage('Build'){
            steps{
                bat 'mvn package -DskipTests -f timesheet '
                bat 'mvn test -f timesheet '
            }
        }
        stage('Deploy & Scan'){
            steps{
                bat 'mvn --version '
                bat 'mvn deploy -f timesheet '
                bat 'mvn sonar:sonar -f timesheet'

            }
            
        }
		
		stage('Build image') { 
            steps { 
                script { 
                    dockerImage = docker.build registry + ":$BUILD_NUMBER" 
                }
            } 
        }
        stage('Deploy image') { 
            steps { 
                script { 
                    docker.withRegistry( '', registryCredential ) { 
                        dockerImage.push() 
                    }
                } 
            }
        } 
        stage('Clean up') { 
   
 steps { 
               bat "docker rmi $registry:$BUILD_NUMBER"
            }
        }  
      
    }
    post { 
        always {            
            deleteDir()
            emailext body: "${currentBuild.currentResult}: Job ${env.JOB_NAME} build ${env.BUILD_NUMBER}\n More info at: ${env.BUILD_URL}",
                        recipientProviders: [[$class: 'DevelopersRecipientProvider'], [$class: 'RequesterRecipientProvider']],
                        subject: "Jenkins Build ${currentBuild.currentResult}: Job ${env.JOB_NAME}",
                        to: '$DEFAULT_REPLYTO'
        }
    }
}
